;; toutes les tentatives qui suivent sont des recherches dont le but est
;; de crer une fonction lisp qui fait prolifrer un ele d'une liste donne
;; jusqu' ce que celui-ci represente un certain pourcentage de la liste.
;; le but MUSICAL tant de faire des notes pivots.


;----------------------------
;; avec init de i  0 :

(defun howmany (ele liste &optional (i 0)) (declare (notinline howmany))
  (cond
     ((endp liste) i)
     ((equal ele (car liste)) (howmany ele (cdr liste) (1+ i)))
     (t                       (howmany ele (cdr liste) i     ))))

;------------(version 2)-----
(defun howmany2 (ele liste) (declare (notinline howmany))
  (let ((i 0))
    (labels ((interne (li)
      ;(prins "li=" li ", " "i=" i)
      (cond
          ((endp li) i)
          ((equal ele (car li)) (setq i (1+ i)) (interne (cdr li)))
          (t                    (interne (cdr li))))))
      (interne liste))))

(defun pourcentage (ele liste)
  (* 100.0 (/ (howmany2 ele liste) (list-length liste))))

;----------------------------

;; model de croitre2 :

(defun croitre2 (li max) (declare (notinline croitre2))
  (let ((lng (list-length li)))
    (if (>= lng max) li
    (let ((ele (nth (random lng) li))
          (pt (random (1+ lng))))
      (croitre2
       (append (firstn2 li pt)
               (list ele)
               (lastn2 li (- lng pt)))
       max)))))

;; lastn2 et firstn2, cf chap 8 lisp N1.
(defun firstn2 (li &optional (n 1))
(butlast li (- (list-length li) n)))

(defun lastn2 (li &optional (n 1))
(reverse (butlast (reverse li) (- (list-length li) n))))

;--------------------------------
;; Fonction proli termine.

(defun proli (ele liste presence%) (declare (notinline proli))
       (let* ((lng (list-length liste))
              (pourcent (* 100.0 (/ (howmany2 ele liste) lng))))
         (if (>= pourcent presence%) liste
            (let ((pt (random (1+ lng))))
              (proli
               ele
               (append (firstn2 liste pt)
                       (list ele)
                       (lastn2 liste (- lng pt)))
               presence%)))))

;--------------------------------------------------------------------------